import 'dart:async';

import 'package:flutter/material.dart';
import 'package:vtmap_gl/vtmap_gl.dart';
import 'main.dart';
import 'page.dart';

class FullMapPage extends ExamplePage {
  FullMapPage() : super(const Icon(Icons.map), 'Full screen map');

  @override
  Widget build(BuildContext context) {
    return const FullMap();
  }
}

class FullMap extends StatefulWidget {
  const FullMap();

  @override
  State createState() => FullMapState();
}

class FullMapState extends State<FullMap> {
  MapboxMapController mapController;
  bool setStyle = false;

  void _onMapCreated(MapboxMapController controller) {
    mapController = controller;
  }

  void _onCameraIdle() {
    // print('------------------- _onCameraIdle');
    // print(mapController.cameraPosition.target.latitude);
    // print(mapController.cameraPosition.target.longitude);
  }

  void _onStyleLoadedCallback() {
    var wayPoints = List<WayPoint>();
    final _stop1 = WayPoint(
        name: "Way Point 2", latitude: 16.065423, longitude: 108.188714);
    final _origin = WayPoint(
        name: "Way Point 1", latitude: 16.059761, longitude: 108.211771);

    wayPoints.add(_origin);
    wayPoints.add(_stop1);

   
    mapController.buildRoute(wayPoints: wayPoints);
    print("--------------------------");
    print(setStyle);
    if (!setStyle) {
      setStyle = true;
      //mapController.setStyle(
      //    'https://api.viettelmaps.vn/gateway/mapservice/v1/media/gtrans_style.json');
    }

    new Timer(const Duration(seconds: 8), () {
      ///print("This line will print after two seconds");
      //mapController.clearRoute();
      //mapController.buildRoute(wayPoints: wayPoints);

       mapController.startNavigation(
        wayPoints: wayPoints,
        options: VTMapOptions(
            mode: VTMapNavigationMode.driving, simulateRoute: true));


    });
  }

  @override
  Widget build(BuildContext context) {
    return new Scaffold(
        body: VTMap(
      accessToken: MapsDemo.ACCESS_TOKEN,
      // gpsControlEnable: true,
      // mapTypeControlEnable: true,
      //styleString: 'https://api.viettelmaps.vn/gateway/mapservice/v1/media/style.json',
      onMapCreated: _onMapCreated,
      onStyleLoadedCallback: _onStyleLoadedCallback,
      onCameraIdle: _onCameraIdle,
      gpsControlEnable: false,
      initialCameraPosition:
          const CameraPosition(target: LatLng(16.065423, 108.188714), zoom: 14),
    ));
  }
}
